#include <tigcclib.h>
#define FULL &(SCR_RECT){{0,0,159,99}}
#define VEGAS (!(style&1))
#define DRAW 1+(style&2)
enum keys {Eenter=13,Eback=257,Eclear=263,Eescape,Eapps,Emode,Ef1=268,Ef2,Ef3,Ef4,Ef5,Ef6,Ef7,Ef8,Ehome=277,Ecatalog,Eup=337,Eleft,Eleftup,Edown,Eupdown,Eleftdown,Eleftupdown,Eright,Eupright,Eleftright,Eleftupright,Erightdown,Euprightdown,Eleftdownright,Euprightleftdown,E2nddimondalpha,Edimondalpha=380,E2nddimondshiftalpha=384,E2ndenter=4109,E2ndescape=4360,E2ndup=4433,E2ndleft,E2ndleftup,E2nddown,E2ndupdown,E2ndleftdown,E2ndrightupdown,E2ndright,E2ndupright,E2ndleftright,E2ndleftupright,E2ndrightdown,E2nduprightdown,E2ndleftdownright,E2nduprightleftdown,Edimondenter=16397,Edimondback=16641,Edimondclear=16647,Edimondescape,Edimondapps,Edimondmode,Edimondup=16721,Edimondleft,Edimondleftup,Edimonddown,Edimondupdown,Edimondleftdown,Edimondrightupdown,Edimondright,Edimondupright,Edimondleftright,Edimondleftupright,Edimondrightdown,Edimonduprightdown,Edimondleftdownright,Edimonduprightleftdown};
enum suits {SPADE,DIAMOND,CLUB,HEART};
enum colors {BLACK,RED};
typedef struct {
	unsigned char numOfCards;
	unsigned char cardsCovered;
	unsigned char card[24];
} PILE;
typedef struct {
	PILE p1;
	PILE p2;
	unsigned char ids;
	unsigned short score;
} HIST;
HIST history[200];
PILE deck,discard,pile[7],aces[4];
INT_HANDLER oldint5=NULL;
unsigned long tick;
unsigned char squeue;
/*
	squeue - queue for the [2nd] button
	0 - no keypress
	1 - key was pressed but not read
	2 - key was pressed and read, waiting for release
	3 - key was released
*/
char bname[18];
DEFINE_INT_HANDLER (myint5handler) {
	tick++;
	if (_keytest(RR_2ND)) {
		if (squeue==0) {
			squeue=1;
			ST_modKey(ST_NONE);
		}
	}
	else {
		if (squeue==1||squeue==2) {
			squeue=3;
		}
	}
    ExecuteHandler(oldint5);
}
unsigned short Sbig[4][12]={{0x0600,0x0f00,0x1f80,0x3fc0,0x7fe0,0x7fe0,0x7fe0,0x7fe0,0x36c0,0x0600,0x0f00,0x1f80},{0x0600,0x0900,0x0900,0x1080,0x1080,0x2040,0x2040,0x1080,0x1080,0x0900,0x0900,0x0600},{0x0600,0x0f00,0x1f80,0x1f80,0x6f60,0xfff0,0xfff0,0xfff0,0x6660,0x0600,0x0f00,0x1f80},{0x30c0,0x4920,0x8610,0x8010,0x8010,0x8010,0x8010,0x4020,0x2040,0x1080,0x0900,0x0600}};
unsigned short SO[]={0x0780,0x1860,0x2010,0x4008,0x4008,0x8004,0x8004,0x8004,0x8004,0x4008,0x4008,0x2010,0x1860,0x0780};
unsigned short SX[]={0xc030,0xe070,0x70e0,0x39c0,0x1f80,0x0f00,0x0f00,0x1f80,0x39c0,0x70e0,0xe070,0xc030};
unsigned char Ssmall[2][4][6]={{{0x20,0x70,0xf8,0xf8,0x20,0x70},{0x20,0x50,0x88,0x88,0x50,0x20},{0x70,0x70,0xf8,0xf8,0x20,0x70},{0x50,0xa8,0x88,0x88,0x50,0x20}},{{0x70,0x20,0xf8,0xf8,0x70,0x20},{0x20,0x50,0x88,0x88,0x50,0x20},{0x70,0x20,0xf8,0xf8,0x70,0x70},{0x20,0x50,0x88,0x88,0xa8,0x50}}};
unsigned char S10[]={0x90,0xa8,0xa8,0xa8,0x90};
unsigned char Sunum[13][5]={{0x50,0x50,0x70,0x50,0x20},{0x70,0x10,0x20,0x40,0x30},{0x30,0x40,0x20,0x40,0x30},{0x40,0x40,0x70,0x50,0x10},{0x30,0x40,0x30,0x10,0x70},{0x70,0x50,0x70,0x10,0x60},{0x10,0x10,0x20,0x40,0x70},{0x70,0x50,0x70,0x50,0x70},{0x30,0x40,0x70,0x50,0x70},{0x48,0xa8,0xa8,0xa8,0x48},{0x70,0x50,0x40,0x40,0x40},{0x50,0x28,0x48,0x48,0x30},{0x90,0x50,0x30,0x50,0x90}};
short money,score;
unsigned char back[82],getColor(unsigned char card),getNum(unsigned char card),getSuit(unsigned char card),hist[2],loadGame(),LOWEST,ocd[4],play(),save,style,validate();
unsigned int seed;
unsigned long endtime;
void *cscr,cycle(),checknmove(),DrawCard(unsigned char x,unsigned char y,unsigned char card),DrawPile(unsigned char pile,unsigned char sel),enterHist(PILE *p1,PILE *p2,unsigned char ids),load(),loadGraphic(),options(),Save(),SaveGame(),*scr,ScrRectSelect(SCR_RECT *rect,SCR_RECT *back),startup(),transfer(PILE *src,PILE *dst,unsigned char num),win();
void _main(void) {
	char fldr[9],var[18];
	SYM_ENTRY *SymPtr;
	if (!(scr=malloc(LCD_SIZE)))
		return;
	hist[0]=200;
	randomize();
	squeue=0;
	bname[0]=0;
	money=0;
	memset(ocd,4,4);
	save=0; // save_undo_buffer:1 remember_winnings:2 remember_settings:1
	style=0; // bits 0 0 0 0 autoflip timed draw# vegas/standard
	sprintf(bname,"main\\pic1");
	load();
	loadGraphic();
	tick=0;
	oldint5=GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_5,myint5handler);
	startup(); // basically runs everything in the game
	SetIntVec(AUTO_INT_5,oldint5);
	free(scr);
	if (save&1)
		Save();
	else {
		fldr[0]=0;
		var[0]=0;
		SymPtr=SymFindFirst(NULL,FO_RECURSE);
		while (SymPtr) {
			if (SymPtr->flags.bits.folder)
				sprintf(fldr,SymPtr->name);
			else if (!strcmp(SymPtr->name,"solsave")) {
				sprintf(var,"%s\\%s",fldr,SymPtr->name);
				break;
			}
			SymPtr=SymFindNext();
		}
		if (!var[0])
			sprintf(var,"solsave");
		EM_moveSymFromExtMem(SYMSTR(var),HS_NULL);
		remove(var);
	}
}
unsigned char getNum(unsigned char card) { // returns the number on card 'card' aces=1 jack=11 queen=12 king=13
	return card%13+1;
}
unsigned char getColor(unsigned char card) { // returns the color of card 'card' (see colors enumeration)
	return (card/13)%2;
}
unsigned char getSuit(unsigned char card) { // returns the suit of card 'card' (see suits enumeration)
	if (card<13)
		return SPADE;
	if (card<26)
		return DIAMOND;
	if (card<39)
		return CLUB;
	return HEART;
}
unsigned char loadGame() { // recovers and deletes a file created by saveGame()
	char fldr[9],var[18];
	unsigned char a;
	FILE *f1;
	SYM_ENTRY *SymPtr;
	fldr[0]=0;
	var[0]=0;
	SymPtr=SymFindFirst(NULL,FO_RECURSE);
	while (SymPtr) {
		if (SymPtr->flags.bits.folder)
			sprintf(fldr,SymPtr->name);
		else if (!strcmp(SymPtr->name,"solgame")) {
			sprintf(var,"%s\\%s",fldr,SymPtr->name);
			break;
		}
		SymPtr=SymFindNext();
	}
	if (!var[0])
		return 0;
	EM_moveSymFromExtMem(SYMSTR(var),HS_NULL);
	f1=fopen(var,"rb");
	fread(&pile,sizeof(PILE),7,f1);
	fread(&aces,sizeof(PILE),4,f1);
	fread(&deck,sizeof(PILE),1,f1);
	fread(&discard,sizeof(PILE),1,f1);
	fread(&score,2,1,f1);
	fread(&tick,sizeof(unsigned long),1,f1);
	fread(&a,1,1,f1);
	fread(&hist,1,2,f1);
	fread(history,sizeof(HIST),hist[1],f1);
	fread(&seed,2,1,f1);
	fclose(f1);
	remove(var);
	style&=0b1000;
	style|=a&0b111;
	return 1;
}
unsigned char play() { // plays a solitaire game
	char timestr[6];
	int k,skey;
	PILE *p1,*p2;
	unsigned char a,b,card,cur[2],fin,mask[52],sel[2],smod,tmp[52];
	void restoreHist() {
		PILE *p;
		unsigned char a;
		if (!hist[1])
			return;
		hist[1]--;
		a=history[hist[1]].ids&15;
		if (a<7)
			p=&pile[a];
		else if (a==7)
			p=&discard;
		else if (a<12)
			p=&aces[a-8];
		else if (a==12)
			p=&deck;
		else
			return;
		memcpy(p,&history[hist[1]].p2,sizeof(PILE));
		DrawPile(a,0);
		a=history[hist[1]].ids>>4;
		if (a<7)
			p=&pile[a];
		else if (a==7)
			p=&discard;
		else if (a<12)
			p=&aces[a-8];
		else if (a==12)
			p=&deck;
		else
			return;
		memcpy(p,&history[hist[1]].p1,sizeof(PILE));
		DrawPile(a,0);
		score=history[hist[1]].score;
		sel[1]=1;
		cur[1]=0;
	}
	/*
		smod
		0 - no second button modification
		1 - second is being held down
		2 - don't act on release
	*/
	srand(seed);
	cscr=LCD_MEM;
	discard.numOfCards=0;
	discard.cardsCovered=0;
	deck.numOfCards=52;
	hist[1]=0;
	memset(mask,0,52);
	for (a=0;a<52;a++) {
		do b=rand()%52;while (mask[b]);
		mask[b]=1;
		tmp[b]=a;
	}
	deck.numOfCards=24;
	for (b=0;b<24;b++)
		deck.card[b]=tmp[b];
	for (a=0;a<7;a++) {
		unsigned char c;
		for (c=0;c<=a;c++,b++)
			pile[a].card[c]=tmp[b];
	}
	for (a=0;a<7;a++) {
		pile[a].numOfCards=a+1;
		pile[a].cardsCovered=a;
	}
	for (a=0;a<4;a++) {
		aces[a].numOfCards=0;
		aces[a].cardsCovered=0;
	}
	if (!(save&6))
		money=0;
	if (VEGAS)
		score=money-52;
	else
		score=0;
	tick=0;
	loadGame();
	smod=2;
	skey=0;
	sel[0]=0;
	sel[1]=1;
	cur[0]=0;
	cur[1]=1;
	clrscr();
	LOWEST=65;
	for (a=0;a<12;a++)
		DrawPile(a,0);
	DrawLine(0,93,159,93,A_NORMAL);
	printf_xy(0,95,"Game number %d",seed);
	printf_xy(130,95,"%c%hd    ",' '+('$'-' ')*(VEGAS),score);
	fin=0;
	while (!fin) {
		DrawPile(sel[0],sel[1]);
		if (cur[0])
			DrawPile(cur[0]-1,cur[1]|128);
		memcpy(scr,LCD_MEM+2820,180);
		do { // basically, a big ngetchx()
			k=0;
			if (kbhit())k=ngetchx();
			if (squeue==1) {
				squeue=2;
				smod=1;
			}
			else if (squeue==3) {
				squeue=0;
				if (smod!=2)
					pushkey(Eenter);
				smod=0;
			}
		} while (k==0);
		memcpy(LCD_MEM+2820,scr,180);
		if (k==Eescape||k==E2ndescape)
			break;
		if (smod==1&&(k==Eright||k==E2ndright||k==Eleft||k==E2ndleft||((k==Edown||k==E2nddown)&&sel[0]>6))) {
			skey=k;
			k=Eenter;
		}
		switch (k) {
			case Eleft:
			case E2ndleft:
				DrawPile(sel[0],0);
				sel[1]=1;
				if (sel[0]==0)
					sel[0]=6;
				else if (sel[0]==7)
					sel[0]=11;
				else
					sel[0]--;
				break;
			case Eright:
			case E2ndright:
				DrawPile(sel[0],0);
				sel[1]=1;
				if (sel[0]==6)
					sel[0]=0;
				else if (sel[0]==11)
					sel[0]=7;
				else
					sel[0]++;
				break;
			case Eup:
			case E2ndup:
				if (sel[0]<7) { // if the user is on a bottom pile
					if (!(smod==1)&&sel[1]<pile[sel[0]].numOfCards-pile[sel[0]].cardsCovered) // if they're moving to an upper pile
						sel[1]++;
					else {
						DrawPile(sel[0],0);
						if (sel[0]<3) {
							sel[0]=7;
							sel[1]=1;
						}
						else {
							sel[0]+=5;
							sel[1]=1;
						}
						if (smod==1)
							smod=2;
					}
				}
				break;
			case Edown:
			case E2nddown:
				if (sel[0]>6) { // if they're on an upper pile
					DrawPile(sel[0],0);
					sel[1]=1;
					if (sel[0]==7)
						sel[0]=1;
					else
						sel[0]-=5;
				}
				else if (pile[sel[0]].numOfCards) {
					if (sel[1]>1)
						sel[1]--;
					else
						sel[1]=pile[sel[0]].numOfCards-pile[sel[0]].cardsCovered;
				}
				break;
			case Eenter:
			case E2ndenter:
				DrawPile(sel[0],0);
				if (hist[1]<hist[0])history[hist[1]].score=score;
				if (skey) {
					pushkey(skey);
					skey=0;
					smod=2;
				}
				if (cur[0]) {
					cur[0]--;
					if (cur[0]==sel[0]) {
						cur[0]=0;
						break;
					}
					if (cur[0]<7)
						p1=&pile[cur[0]];
					else if (cur[0]==7)
						p1=&discard;
					else
						p1=&aces[cur[0]-8];
					card=p1->card[p1->numOfCards-cur[1]];
					if (sel[0]<7) { // If the card is going on to a regular pile
						p2=&pile[sel[0]];
						if (p2->numOfCards==0) {
							if (getNum(card)!=13) {
								cur[0]++;
								break;
							}
							if (cur[0]>7) {
								if (VEGAS)
									score-=5;
								else
									score-=10;
							}
						}
						else if (p2->numOfCards==p2->cardsCovered||getColor(card)==getColor(p2->card[p2->numOfCards-1])||getNum(card)+1!=getNum(p2->card[p2->numOfCards-1])) {
							cur[0]++;
							break;
						}
						else if (cur[0]>7) {
							if (VEGAS)
								score-=5;
							else
								score-=10;
						}
						else if (cur[0]==7&&!VEGAS)
							score+=5;
					}
					else if (sel[0]==7) {
						cur[0]++;
						break;
					}
					else {
						p2=&aces[sel[0]-8];
						if (cur[1]!=1||(p2->numOfCards==0&&getNum(card)!=1)||(p2->numOfCards>0&&(getSuit(p2->card[p2->numOfCards-1])!=getSuit(card)||getNum(card)!=getNum(p2->card[p2->numOfCards-1])+1))) {
							cur[0]++;
							break;
						}
						if (cur[0]<8) {
							if (VEGAS)
								score+=5;
							else
								score+=10;
						}
					}
					enterHist(p1,p2,(cur[0]<<4)+sel[0]);
					transfer(p1,p2,cur[1]);
					if ((style&8)&&cur[0]<7&&pile[cur[0]].numOfCards>0&&pile[cur[0]].numOfCards==pile[cur[0]].cardsCovered) // flips the top card if autoflip is set
						pile[cur[0]].cardsCovered--;
					if (cur[0]==7&&discard.numOfCards&&discard.numOfCards==discard.cardsCovered)
						discard.cardsCovered--;
					DrawPile(cur[0],0);
					cur[0]=0;
				}
				else {
					if (sel[0]<7) {
						if (pile[sel[0]].cardsCovered==pile[sel[0]].numOfCards&&pile[sel[0]].numOfCards>0) { // if the top card is covered
							pile[sel[0]].cardsCovered--;
							if (!VEGAS)
								score+=5;
						}
						else if (pile[sel[0]].numOfCards>0&&pile[sel[0]].cardsCovered<pile[sel[0]].numOfCards) {
							cur[0]=sel[0]+1;
							cur[1]=sel[1];
						}
					}
					else if (sel[0]==7) {
						if (discard.numOfCards) {
							cur[0]=sel[0]+1;
							cur[1]=sel[1];
						}
					}
					else {
						if (aces[sel[0]-8].numOfCards) {
							cur[0]=sel[0]+1;
							cur[1]=sel[1];
						}
					}
				}
				break;
			case Ef5:
				if (LOWEST==72) { // the status bar is down
					LOWEST=65;
					ScrRectFill(&(SCR_RECT){{0,94,159,99}},FULL,A_REVERSE);
					DrawLine(0,93,159,93,A_NORMAL);
					printf_xy(0,95,"Game number %d",seed);
					printf_xy(130,95,"%c%hd    ",' '+('$'-' ')*(VEGAS),score);
				}
				else {
					ScrRectFill(&(SCR_RECT){{0,93,159,99}},FULL,A_REVERSE);
					LOWEST=72;
				}
				for (a=0;a<7;a++)
					DrawPile(a,0);
				break;
			case Ef2:
			case Ef7:
				checknmove();
				break;
			case Ef1:
			case Ef6:
				if (deck.numOfCards&&!cur[0]) {
					history[hist[1]].score=score;
					enterHist(&discard,&deck,124);
					discard.cardsCovered=discard.numOfCards;
					for (a=0;a<DRAW;a++) {
						if (deck.numOfCards)
							transfer(&deck,&discard,1);
					}
					DrawPile(7,0);
				}
				else if (!deck.numOfCards) {
					if (!VEGAS) {
						history[hist[1]].score=score;
						enterHist(&discard,&deck,124);
						cycle();
						DrawPile(7,0);
						score-=100;
						if (score<0)
							score=0;
					}
				}
				break;
			case Eback:
			case 4353: // 2nd back
				restoreHist();
				break;
		}
		if (aces[0].numOfCards+aces[1].numOfCards+aces[2].numOfCards+aces[3].numOfCards==52)
			fin=1;
		if (LOWEST==65) {
			printf_xy(0,95,"Game number %d",seed);
			printf_xy(130,95,"%c%hd    ",' '+('$'-' ')*VEGAS,score);
		}
	}
	if (VEGAS&&save&6)
		money=score;
	if (fin) {
		endtime=tick/19;
		win();
		FontSetSys(F_6x8);
		if (style&4) {
			sprintf(timestr,"%lu:%lu",endtime/60,endtime%60);
			ScrRectFill(&(SCR_RECT){{(160-6*strlen(timestr))/2-2,24,82+3*strlen(timestr),34}},FULL,A_NORMAL);
			ScrRectFill(&(SCR_RECT){{(160-6*strlen(timestr))/2-1,25,81+3*strlen(timestr),33}},FULL,A_REVERSE);
			DrawStr((160-6*strlen(timestr))/2,26,timestr,A_NORMAL);
		}
		ScrRectFill(&(SCR_RECT){{0,86,159,99}},FULL,A_REVERSE);
		DrawLine(0,85,159,85,A_NORMAL);
		DrawLine(0,93,159,93,A_NORMAL);
		FontSetSys(F_4x6);
		printf_xy(0,87,"Game number %d",seed);
		printf_xy(130,87,"%c%hd    ",' '+('$'-' ')*(VEGAS),score);
		DrawStr(2,95,"Exit",A_NORMAL);
		DrawStr(66,95,"Restart",A_NORMAL);
		DrawStr(106,95,"New",A_NORMAL);
		DrawStr(136,95,"Choose",A_NORMAL);
		do k=ngetchx();while (k!=Eescape&&k!=Ef1&&k!=Ef3&&k!=Ef4&&k!=Ef5);
		switch (k) {
			case Eescape:
			case Ef1:return 0;break;
			case Ef4:return 1;break;
			case Ef3:return 2;break;
			case Ef5:return 3;break;
		}
	}
	else {
		ScrRectFill(&(SCR_RECT){{0,94,159,99}},FULL,A_REVERSE);
		DrawLine(0,93,159,93,A_NORMAL);
		FontSetSys(F_4x6);
		DrawStr(2,95,"Exit",A_NORMAL);
		DrawStr(35,95,"Save",A_NORMAL);
		DrawStr(66,95,"Restart",A_NORMAL);
		DrawStr(106,95,"New",A_NORMAL);
		DrawStr(136,95,"Choose",A_NORMAL);
		do k=ngetchx();while (k!=Eescape&&(k<Ef1||k>Ef5));
		switch (k) {
			case Ef2:SaveGame();
			case Eescape:
			case Ef1:return 0;break;
			case Ef4:return 1;break;
			case Ef3:return 2;break;
			case Ef5:return 3;break;
		}
	}
	return 0;
}
unsigned char validate() { // makes sure that the file in bname is actually a PIC file with 26 rows and 18 columns
	FILE *f1;
	f1=fopen(bname,"rb");
	if (f1) {
		if (fgetc(f1)!=0||fgetc(f1)!=26||fgetc(f1)!=0||fgetc(f1)!=18) // checks to see if there are 26 rows and 18 columns
			return 0;
		fseek(f1,-1,SEEK_END);
		if (fgetc(f1)!=223) // checks to see if the file is in fact a PIC file
			return 0;
		fclose(f1);
	}
	else
		return 0;
	return 1;
}
void checknmove() { // checks for and moves any cards that can be legally moved to the top
	unsigned char a,b,card,card2;
	PILE *p;
	while (1) {
		for (a=1;a<9;a++) { // piles
			if (a==8)
				p=&discard;
			else
				p=&pile[a-1];
			if (p->numOfCards==0||p->numOfCards==p->cardsCovered)
				continue;
			for (b=0;b<4;b++) {
				card=p->card[p->numOfCards-1];
				card2=aces[b].card[aces[b].numOfCards-1];
				if (aces[b].numOfCards==0) { // the spot is empty
					if (getNum(card)==1&&(ocd[0]==4||ocd[b]==getSuit(card))) {   // and the card is an ace and fits the OCD setting (if turned on)
						history[hist[1]].score=score;
						enterHist(p,&aces[b],((a-1)<<4)+8+b);
						transfer(p,&aces[b],1);
						if (a==8&&discard.numOfCards&&discard.numOfCards==discard.cardsCovered)
							discard.cardsCovered--;
						if ((style&8)&&a<8&&p->numOfCards&&p->numOfCards==p->cardsCovered) // autoflip
							p->cardsCovered--;
						if (VEGAS)
							score+=5;
						else
							score+=10;
						DrawPile(a-1,0);
						DrawPile(b+8,0);
						a=0;
						b=4;
					}
				}
				else if (getSuit(card)==getSuit(card2)&&getNum(card2)+1==getNum(card)) {
					history[hist[1]].score=score;
					enterHist(p,&aces[b],((a-1)<<4)+8+b);
					transfer(p,&aces[b],1);
					if (a==8&&discard.numOfCards&&discard.numOfCards==discard.cardsCovered)
						discard.cardsCovered--;
					if ((style&8)&&a<8&&p->numOfCards&&p->numOfCards==p->cardsCovered) // autoflip
						p->cardsCovered--;
					if (VEGAS)
						score+=5;
					else
						score+=10;
					DrawPile(a-1,0);
					DrawPile(b+8,0);
					a=0;
					b=4;
				}
			}
		}
		
		break;
	}
}
void cycle() { // moves the cards in discard back to deck
	while (discard.numOfCards)
		transfer(&discard,&deck,1);
}
void DrawCard(unsigned char x,unsigned char y,unsigned char card) { // draws card 'card' at position x,y on the screen
	FontSetSys(F_4x6);
	ScrRectFill(&(SCR_RECT){{x+2,y,x+17,y+27}},FULL,A_REVERSE);
	ScrRectFill(&(SCR_RECT){{x,y+2,x+19,y+25}},FULL,A_REVERSE);
	DrawLine(x+2,y,x+17,y,A_NORMAL);
	DrawLine(x+19,y+2,x+19,y+25,A_NORMAL);
	DrawLine(x+2,y+27,x+17,y+27,A_NORMAL);
	DrawLine(x,y+2,x,y+25,A_NORMAL);
	DrawPix(x+1,y+1,A_NORMAL);
	DrawPix(x+18,y+1,A_NORMAL);
	DrawPix(x+18,y+26,A_NORMAL);
	DrawPix(x+1,y+26,A_NORMAL);
	if (card==53) // blank card
		return;
	else if (card==52) { // back of a card
		BitmapPut(x+1,y+1,&back,FULL,A_NORMAL);
		return;
	}
	Sprite8(x+13,y+1,6,Ssmall[0][getSuit(card)],cscr,SPRT_XOR);
	Sprite8(x+2,y+21,6,Ssmall[1][getSuit(card)],cscr,SPRT_XOR);
	Sprite16(x+4,y+8,12,Sbig[getSuit(card)],cscr,SPRT_XOR);
	Sprite8(x+13,y+21,5,Sunum[getNum(card)-1],cscr,SPRT_XOR);
	switch (getNum(card)) {
		case 1:DrawChar(x+2,y+2,'A',A_NORMAL);break;
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:DrawChar(x+2,y+2,getNum(card)+48,A_NORMAL);break;
		case 10:Sprite8(x+2,y+2,5,S10,cscr,SPRT_XOR);break;
		case 11:DrawChar(x+2,y+2,'J',A_NORMAL);break;
		case 12:DrawChar(x+2,y+2,'Q',A_NORMAL);break;
		case 13:DrawChar(x+2,y+2,'K',A_NORMAL);break;
	}
}
void DrawPile(unsigned char p,unsigned char sel) { // draws a pile. 0-6 are the bottom piles from left to right, 7 is the discard/draw pile, and 8-11 are the end piles respectively from left to right
	unsigned char b,ey,highlight,selh,y;
	memcpy(scr,LCD_MEM,LCD_SIZE);
	PortSet(scr,239,127);
	cscr=scr;
	highlight=0;
	if (sel&128) {
		sel&=127;
		highlight=1;
	}
	selh=0;
	ey=0;
	switch (p) {
		case 0 ... 6: // the piles
			ScrRectFill(&(SCR_RECT){{4+22*p,30,23+22*p,LOWEST+27}},FULL,A_REVERSE); // erase anything that is in the pile's spot
			y=30;
			for (b=0;b<pile[p].cardsCovered;b++) { // draw the hidden cards
				DrawCard(4+22*p,y,52);
				ey=y+27;
				y+=2;
			}
			if (sel==1&&pile[p].numOfCards==pile[p].cardsCovered) { // if an empty spot, or a covered card, is selected
				if (pile[p].numOfCards==0)
					ScrRectSelect(&(SCR_RECT){{4+22*p,y,23+22*p,y+27}},FULL);
				else
					ScrRectSelect(&(SCR_RECT){{4+22*p,y-2,23+22*p,ey}},FULL);
			}
			if (pile[p].numOfCards>pile[p].cardsCovered) { // if there are cards that are flipped visable
				DrawCard(4+22*p,y,pile[p].card[b]); // shows the first uncovered card
				if (sel==pile[p].numOfCards-b) // if this is the card selected
					selh=y;
				ey=y+27;
				y+=7;
				b++;
				if (y+(pile[p].numOfCards-b-1)*7>LOWEST) {
					unsigned char spaces[2];
					if (sel>1&&sel<pile[p].numOfCards-pile[p].cardsCovered) {
						spaces[0]=(LOWEST-y-8)%(pile[p].numOfCards-b-2);
						spaces[1]=(LOWEST-y-8)/(pile[p].numOfCards-b-2);
					}
					else {
						spaces[0]=(LOWEST-y)%(pile[p].numOfCards-b-1);
						spaces[1]=(LOWEST-y)/(pile[p].numOfCards-b-1);
					}
					while (b<pile[p].numOfCards) {
						DrawCard(4+22*p,y,pile[p].card[b]);
						ey=y+27;
						if (sel==pile[p].numOfCards-b) {
							selh=y;
							y+=8;
						}
						else {
							if (spaces[0]) {
								spaces[0]--;
								y++;
							}
							y+=spaces[1];
						}
						b++;
					}
				}
				else { // no shrinking needed
					while (b<pile[p].numOfCards) { // draws the 
						DrawCard(4+22*p,y,pile[p].card[b]);
						ey=y+27;
						if (sel==pile[p].numOfCards-b)
							selh=y;
						y+=7;
						b++;
					}
				}
				if (sel) {
					if (highlight)
						ScrRectFill(&(SCR_RECT){{4+22*p,selh,23+22*p,ey}},FULL,A_XOR);
					else
						ScrRectSelect(&(SCR_RECT){{4+22*p,selh,23+22*p,ey}},FULL);
				}
			}
			break;
		case 7: // draw pile
			DrawCard(4,1,52);
			if (!deck.numOfCards) {
				DrawCard(4,1,53);
				if (VEGAS)
					Sprite16(8,9,12,SX,scr,SPRT_XOR);
				else
					Sprite16(7,8,14,SO,scr,SPRT_XOR);
			}
			ScrRectFill(&(SCR_RECT){{26,1,61,28}},FULL,A_REVERSE);
			if (discard.numOfCards) {
				for (b=discard.cardsCovered;b<discard.numOfCards;b++)
					DrawCard(26+8*(b-discard.cardsCovered),1,discard.card[b]);
			}
			if (sel) {
				if (highlight) {
					if (discard.numOfCards)
						ScrRectFill(&(SCR_RECT){{26+8*(discard.numOfCards-discard.cardsCovered-1),1,45+8*(discard.numOfCards-discard.cardsCovered-1),28}},FULL,A_XOR);
					else
						ScrRectFill(&(SCR_RECT){{26,1,45,28}},FULL,A_XOR);
				}
				else {
					if (discard.numOfCards)
						ScrRectSelect(&(SCR_RECT){{26+8*(discard.numOfCards-discard.cardsCovered-1),1,45+8*(discard.numOfCards-discard.cardsCovered-1),28}},FULL);
					else
						ScrRectSelect(&(SCR_RECT){{26,1,45,28}},FULL);
				}
			}
			break;
		case 8:
		case 9:
		case 10:
		case 11:// aces
			if (aces[p-8].numOfCards)
				DrawCard(70+22*(p-8),1,aces[p-8].card[aces[p-8].numOfCards-1]);
			else
				DrawCard(70+22*(p-8),1,53);
			if (sel) {
				if (highlight)
					ScrRectFill(&(SCR_RECT){{70+22*(p-8),1,89+22*(p-8),28}},FULL,A_XOR);
				else
					ScrRectSelect(&(SCR_RECT){{70+22*(p-8),1,89+22*(p-8),28}},FULL);
			}
			break;
	}
	memcpy(LCD_MEM,scr,LCD_SIZE);
	PortSet(LCD_MEM,239,127);
	cscr=LCD_MEM;
}
void enterHist(PILE *p1,PILE *p2,unsigned char ids) { // loads a history entry into the undo buffer.
	memcpy(&history[hist[1]].p1,p1,sizeof(PILE));
	memcpy(&history[hist[1]].p2,p2,sizeof(PILE));
	history[hist[1]].ids=ids;
	hist[1]++;
	if (hist[1]==hist[0]) {
		if (!hist[0])
			return;
		memmove(history,history+1,sizeof(history)-sizeof(HIST));
		hist[1]--;
	}
}
void load() { // loads prefrences
	char fldr[9],var[18];
	FILE *f1;
	SYM_ENTRY *SymPtr;
	unsigned char a;
	fldr[0]=0;
	var[0]=0;
	SymPtr=SymFindFirst(NULL,FO_RECURSE);
	while (SymPtr) {
		if (SymPtr->flags.bits.folder)
			sprintf(fldr,SymPtr->name);
		else if (!strcmp(SymPtr->name,"solsave")) {
			sprintf(var,"%s\\%s",fldr,SymPtr->name);
			break;
		}
		SymPtr=SymFindNext();
	}
	if (!var[0])
		return;
	if (!save&1)
		save++;
	EM_moveSymFromExtMem(SYMSTR(var),HS_NULL);
	f1=fopen(var,"rb");
	save=fgetc(f1);
	if (save&2)
		fread(&money,2,1,f1);
	style=fgetc(f1);
	a=0;
	do {
		bname[a]=fgetc(f1);
		a++;
	} while (bname[a-1]);
	fread(ocd,1,4,f1);
	fclose(f1);
	EM_moveSymToExtMem(SYMSTR(var),HS_NULL);
}
void loadGraphic() { // fills back with the picture stored in the file bname
	FILE *f1;
	unsigned char a;
	memset(back,0,82);
	back[1]=26;
	back[3]=18;
	if (!validate())
		return;
	f1=fopen(bname,"rb");
	if (f1) {
		fseek(f1,4,SEEK_SET);
		for (a=0;a<78;a++)
			back[a+4]=fgetc(f1);
		fclose(f1);
	}
}
void options() { // displays the options
	int k;
	unsigned char p;
	void OCD() {
		int k;
		unsigned char a,b;
		void DrawCards() {
			unsigned char a; // 25208
			for (a=0;a<4;a++)
				DrawCard(10+21*a,55,13*ocd[a]);
			DrawStr(0,89,"Hold 2nd while pressing arrows to move a card",A_NORMAL);
			FontSetSys(F_6x8);
		}
		void toggle() {
			if (a==0) {
				if (ocd[0]==4)
					ScrRectFill(&(SCR_RECT){{5,39,121,48}},FULL,A_XOR);
				else
					ScrRectFill(&(SCR_RECT){{5,39,151,48}},FULL,A_XOR);
			}
			else
				ScrRectFill(&(SCR_RECT){{10+21*b,55,29+21*b,82}},FULL,A_XOR);
		}
		clrscr();
		cscr=LCD_MEM;
		printf("The OCD setting lets you\ndefine a specific order\nthe suits fill in up top\nwhen you hit F2.\n\n ");
		if (ocd[0]==4)
			printf("Use the OCD setting");
		else {
			printf("Turn off the OCD setting");
			DrawCards();
		}
		a=0;
		b=0;
		while (1) {
			toggle();
			k=ngetchx();
			toggle();
			switch (k) {
				case Eescape:return;break;
				case Eenter:
					if (a==0) {
						if (ocd[0]==4) {
							ocd[0]=0;
							ocd[1]=1;
							ocd[2]=2;
							ocd[3]=3;
							DrawStr(6,40,"Turn off the OCD setting",A_REPLACE);
							DrawCards();
						}
						else {
							memset(ocd,4,4);
							DrawStr(6,40,"Use the OCD setting     ",A_REPLACE);
							ScrRectFill(&(SCR_RECT){{0,50,159,99}},FULL,A_REVERSE);
						}
					}
					break;
				case Eup:a=b=0;break;
				case Edown:if (ocd[0]<4)a=1;break;
				case Eleft:if (a==1&&b)b--;break;
				case Eright:if (a==1&&b<3)b++;break;
				case E2ndleft:
					if (a==1&&b) {
						b--;
						a=ocd[b];
						ocd[b]=ocd[b+1];
						ocd[b+1]=a;
						a=1;
						DrawCards();
					}
					break;
				case E2ndright:
					if (a==1&&b<3) {
						b++;
						a=ocd[b];
						ocd[b]=ocd[b-1];
						ocd[b-1]=a;
						a=1;
						DrawCards();
					}
					break;
			}
		}
	}
	p=0;
	while (1) {
		clrscr();
		if (VEGAS)
			printf("  Vegas scoring");
		else
			printf("  Standard scoring");
		printf("\n  Draw %d\n  ",DRAW);
		if (style&4)
			printf("Timed");
		else
			printf("Untimed");
		printf("\n  ");
		if (style&8)
			printf("Autoflip on");
		else
			printf("Autoflip off");
		printf("\n  ");
		if (save&8)
			printf("Save Undo buffer w/game");
		else
			printf("Don't save undo buffer");
		printf("\n  OCD setting ");
		if (ocd[0]<4)
			printf("On");
		else
			printf("Off");
		printf("\n  Change card graphic\n  ");
		if ((save&6)==0)
			printf("Don't save winnings");
		else if ((save&6)==2)
			printf("Save winnings");
		else
			printf("Reset winnings on exit");
		printf("\n  ");
		if (save&1)
			printf("Save settings");
		else
			printf("Don't save settings");
		printf("\n  Exit");
		k=0;
		while (!k) {
			DrawChar(0,p<<3,'>',A_XOR);
			do {
				k=0;
				if (kbhit())k=ngetchx();
				if (squeue==1) {
					pushkey(Ef1);
					squeue=2;
				}
				else if (squeue==3)
					squeue=0;
			} while (k!=Eup&&k!=Edown&&k!=Eenter&&k!=Ef1&&k!=E2ndup&&k!=E2nddown&&k!=Eescape&&k!=4360);
			DrawChar(0,p<<3,'>',A_XOR);
			switch (k) {
				case Eup:
				case E2ndup:
					if (p==0)
						p=9;
					else
						p--;
					k=0;
					break;
				case Edown:
				case E2nddown:
					if (p==9)
						p=0;
					else
						p++;
					k=0;
					break;
				case Eenter:
				case E2ndenter:
				case Ef1:
				case Ef6:
					switch (p) {
						case 0:style^=1;break;
						case 1:style^=2;break;
						case 2:style^=4;break;
						case 3:style^=8;break;
						case 4:save^=8;break;
						case 5:OCD();break;
						case 6:
							clrscr();
							printf("Current graphic\n%s\n\n\n\n\nAre you sure you want to\nchange it?",bname);
							DrawStr(2,91,"Yes",A_NORMAL);
							DrawStr(145,91,"No",A_NORMAL);
							DrawCard(0,16,52);
							FontSetSys(F_6x8);
							do k=ngetchx();while (k!=Ef1&&k!=Ef5);
							if (k==Ef5)
								break;
							clrscr();
							FontSetSys(F_6x8);
							printf("New graphic name (include folder name): ");
							FontSetSys(F_4x6);
							DrawStr(0,87,"Graphic files must be PIC files with 26 rows",A_NORMAL);
							DrawStr(0,93,"and 18 columns or graphic will default to blank",A_NORMAL);
							FontSetSys(F_6x8);
							getsn(bname,17);
							loadGraphic();
							break;
						case 7:
							if ((save&6)==0)
								save|=3;
							else if ((save&6)==2)
								save+=2;
							else
								save-=4;
							break;
						case 8:
							if (save&1)
								save&=11111000;
							else
								save++;
							break;
					}
					break;
			}
		}
		if (k==Eescape||k==4360/* 2nd Escape */||((k==Eenter||k==Ef1)&&p==9))
			break;
	}
}
void Save() { // saves prefrences
	char fldr[9],var[18];
	FILE *f1;
	SYM_ENTRY *SymPtr;
	fldr[0]=0;
	var[0]=0;
	SymPtr=SymFindFirst(NULL,FO_RECURSE);
	while (SymPtr) {
		if (SymPtr->flags.bits.folder)
			sprintf(fldr,SymPtr->name);
		else if (!strcmp(SymPtr->name,"solsave")) {
			sprintf(var,"%s\\%s",fldr,SymPtr->name);
			break;
		}
		SymPtr=SymFindNext();
	}
	if (!var[0])
		sprintf(var,"solsave");
	else
		EM_moveSymFromExtMem(SYMSTR(var),HS_NULL);
	f1=fopen(var,"wb");
	fputc(save,f1);
	if (save&2)
		fwrite(&money,2,1,f1);
	fputc(style,f1);
	fwrite(bname,1,strlen(bname)+1,f1);
	fwrite(ocd,1,4,f1);
	fputc(0,f1);
	fputc('S',f1);
	fputc('o',f1);
	fputc('l',f1);
	fputc(0,f1);
	fputc(OTH_TAG,f1);
	fclose(f1);
	EM_moveSymToExtMem(SYMSTR(var),HS_NULL);
}
void SaveGame() { // saves a game for later recovery by loadGame()
	FILE *f1;
	f1=fopen("solgame","wb");
	fwrite(&pile,sizeof(PILE),7,f1);
	fwrite(&aces,sizeof(PILE),4,f1);
	fwrite(&deck,sizeof(PILE),1,f1);
	fwrite(&discard,sizeof(PILE),1,f1);
	fwrite(&score,2,1,f1);
	fwrite(&tick,sizeof(unsigned long),1,f1);
	fwrite(&style,1,1,f1);
	hist[1]*=(!(!(save&8)));
	fwrite(&hist,1,2,f1);
	fwrite(history,sizeof(HIST),hist[1],f1);
	fwrite(&seed,2,1,f1);
	fwrite(ocd,1,4,f1);
	fputc(0,f1);
	fputc('S',f1);
	fputc('g',f1);
	fputc('m',f1);
	fputc('e',f1);
	fputc(0,f1);
	fputc(OTH_TAG,f1);
	fclose(f1);
	EM_moveSymToExtMem(SYMSTR("solgame"),HS_NULL);
}
void ScrRectSelect(SCR_RECT *rect,SCR_RECT *back) { // ORs a border rectangle 2 px thick
	ScrRectFill(&(SCR_RECT){{rect->xy.x0,rect->xy.y0,rect->xy.x0+1,rect->xy.y1}},back,A_NORMAL);
	ScrRectFill(&(SCR_RECT){{rect->xy.x0,rect->xy.y0,rect->xy.x1,rect->xy.y0+1}},back,A_NORMAL);
	ScrRectFill(&(SCR_RECT){{rect->xy.x0,rect->xy.y1-1,rect->xy.x1,rect->xy.y1}},back,A_NORMAL);
	ScrRectFill(&(SCR_RECT){{rect->xy.x1-1,rect->xy.y0,rect->xy.x1,rect->xy.y1}},back,A_NORMAL);
}
void startup() { // shows the screen at startup
	int k;
	unsigned char p;
	unsigned char choose() {
		unsigned char a;
		FontSetSys(F_6x8);
		clrscr();
		printf("Enter game number:");
		a=0;
		seed=0;
		while (1) {
			DrawChar(6*a,8,'_',A_XOR);
			k=ngetchx();
			DrawChar(6*a,8,'_',A_XOR);
			switch (k) {
				case '0' ... '9':
					if (a==5)
						break;
					seed=seed*10+k-48;
					if (seed>RAND_MAX) {
						seed/=10;
						break;
					}
					DrawChar(6*a,8,k,A_XOR);
					a++;
					break;
				case Eback:
					if (!a)
						break;
					a--;
					seed/=10;
					DrawChar(6*a,8,' ',A_REPLACE);
					break;
				case Eenter:return 0;break;
				case Eescape:return 1;break;
			}
		}
		return 0;
	}
	p=0;
	while (1) {
		FontSetSys(F_6x8);
		k=0;
		while (k!=Eescape&&k!=Eenter&&k!=Ef1) {
			clrscr();
			printf("Solitaire!\n\n  Play\n  Choose game\n  Options\n  Exit");
			DrawChar(0,(p+2)<<3,'>',A_XOR);
			do { // one big ngetchx()
				k=0;
				if (kbhit())k=ngetchx();
				if (squeue==1) {
					k=Ef1;
					squeue=2;
				}
				else if (squeue==3)
					squeue=0;
			} while (k!=Eescape&&k!=Eup&&k!=Edown&&k!=E2ndup&&k!=E2nddown&&k!=Eenter&&k!=Ef1);
			DrawChar(0,(p+1)<<3,'>',A_XOR);
			switch (k) {
				case Eup:
				case E2ndup:
					if (p==0)
						p=3;
					else
						p--;
					break;
				case Edown:
				case E2nddown:
					if (p==3)
						p=0;
					else
						p++;
					break;
			}
		}
		if (k==Eescape||p==3)
			break;
		switch (p) {
			case 0:seed=rand();
			case 1:
				if(p&&choose()) {
					k=0;
					break;
				}
				p=1;
				while(p) {
					p=play();
					switch (p) {
						case 1:seed=rand();break;
						case 3:p=!choose();break;
					}
				}
				break;
			case 2:options();break;
		}
	}
}
void transfer(PILE *src,PILE *dst,unsigned char num) { // transfers num cards from src to dest
	unsigned char a;
	for (a=0;a<num;a++) {
		dst->card[dst->numOfCards]=src->card[src->numOfCards-num+a];
		dst->numOfCards++;
	}
	src->numOfCards-=num;
}
void win() { // displays the cool cards bouncing away animation at the end of the game
	unsigned char a;
	short vx,vy,width,x,y;
	char card[BitmapSize(&(SCR_RECT){{0,0,20,28}})];
	while (aces[0].numOfCards+aces[1].numOfCards+aces[2].numOfCards+aces[3].numOfCards>0&&!kbhit()) {
		for (a=0;a<4;a++) {
			if (!aces[a].numOfCards)
				continue;
			DrawPile(a+8,0);
			BitmapGet(&(SCR_RECT){{70+22*a,1,89+22*a,28}},&card);
			x=72+22*a;
			y=1;
			vx=(rand()%3+1)*(1-2*(rand()%2));
			vy=0;
			width=20;
			while (x>-20&&x<160&&!kbhit()) {
				x+=vx;
				y+=vy;
				if (x<0) {
					if (width<=-vx)
						break;
					BitmapGet(&(SCR_RECT){{(x-vx)-x,y-vy,x-vx+width-1,y-vy+27}},&card);
					width+=x;
					x=0;
				}
				if (y>71) {
					y=71;
					vy=-vy+2;
				}
				BitmapPut(x,y,&card,FULL,A_REPLACE);
				vy+=1;
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
				cos(PI);
			}
			aces[a].numOfCards--;
		}
	}
	if (kbhit())
		ngetchx();
}
